Codeforces Round #271 (Div. 2) F题 Ant colony(线段树求区间gcd)


F. Ant colony
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Mole is hungry again. He found one ant colony, consisting of n ants, ordered in a row. Each ant i (1 ≤ i ≤ n) has a strength si.

In order to make his dinner more interesting, Mole organizes a version of «Hunger Games» for the ants. He chooses two numbers l and r(1 ≤ l ≤ r ≤ n) and each pair of ants with indices between l and r (inclusively) will fight. When two ants i and j fight, ant i gets one battle point only if si divides sj (also, ant j gets one battle point only if sj divides si).

After all fights have been finished, Mole makes the ranking. An ant i, with vi battle points obtained, is going to be freed only if vi = r - l, or in other words only if it took a point in every fight it participated. After that, Mole eats the rest of the ants. Note that there can be many ants freed or even none.

In order to choose the best sequence, Mole gives you t segments [li, ri] and asks for each of them how many ants is he going to eat if those ants fight.

Input

The first line contains one integer n (1 ≤ n ≤ 105), the size of the ant colony.

The second line contains n integers s1, s2, ..., sn (1 ≤ si ≤ 109), the strengths of the ants.

The third line contains one integer t (1 ≤ t ≤ 105), the number of test cases.

Each of the next t lines contains two integers li and ri (1 ≤ li ≤ ri ≤ n), describing one query.

Output

Print to the standard output t lines. The i-th line contains number of ants that Mole eats from the segment [li, ri].

Sample test(s)
input
5
1 3 2 4 2
4
1 5
2 5
3 5
4 5
output
4
4
1
1
Note

In the first test battle points for each ant are v = [4, 0, 2, 0, 2], so ant number 1 is freed. Mole eats the ants 2345.

In the second test case battle points are v = [0, 2, 0, 2], so no ant is freed and all of them are eaten by Mole.

In the third test case battle points are v = [2, 0, 2], so ants number 3 and 5 are freed. Mole eats only the ant 4.

In the fourth test case battle points are v = [0, 1], so ant number 5 is freed. Mole eats the ant 4.






题意:已给数列,给定一个区间,求区间内的某个数x可以整除区间内所有值,求此x的个数

显然个数就是区间内gcd(al,al+1,al+2,...,ar-1,ar)的个数

求任何区间的gcd,可以用线段树解决

求任何区间内某个数的个数可以:先用pair记录值和index,再排序用二分确定上下界,单次复杂度是Ologn

#include<cstdio>
#include<iostream>
#include<cstring>
#include<algorithm>
using namespace std;

#define root 1,n,1
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1

const int N = 1e5+100;
typedef pair<int,int >pii;
int d[N<<2];
int a[N];
pii b[N];
int gcd(int a,int b)
{
    if(b==0) return a;
    else return gcd(b,a%b);
}
void pushup(int rt)
{
    d[rt]=gcd(d[rt<<1],d[rt<<1|1]);
}
void build(int l,int r,int rt)
{
    if(l==r) {d[rt]=a[l];return;}
    int m=(l+r)>>1;
    build(lson);
    build(rson);
    pushup(rt);
}
int query(int L,int R,int l,int r,int rt)
{
    if(L<=l&&r<=R) return d[rt];
    int m=(l+r)>>1;
    int x,y;
    x=y=0;
    if(L<=m) x=query(L,R,lson);
    if(R>m) y=query(L,R,rson);
    return gcd(x,y);
}

int main()
{
    int n,t;
    cin>>n;
    for(int i=1;i<=n;i++) cin>>a[i],b[i].first=a[i],b[i].second=i;
    build(root);
    sort(b+1,b+1+n);
    cin>>t;
    for(int i=1;i<=t;i++)
    {
        int l,r;
        scanf("%d%d",&l,&r);
        int gd=query(l,r,root);
        int fr=lower_bound(b+1,b+n+1,pii(gd,l))-(b+1);
        int ba=lower_bound(b+1,b+1+n,pii(gd,r+1))-(b+1);
        printf("%d\n",(r-l+1)-(ba-fr));
    }

}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值